<?php
/**
 * @ H2N Link Directory dTree 2.0.0 helper.php
 * @ Copyright (C) 2008 Harry Klein - joomla.neschke.eu
 * @
 * @ Link Directory dTree 1.0.0 mod_ld_dtree.php
 * @ Copyright (C) 2004 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 * @
 * @ $Id: helper.php,v 1.7 2008/06/14 19:38:37 neschkeh Exp $
 * @
 **/
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.');

$path = preg_replace("!(\\\)!i","/",dirname(__FILE__));
defined('_LD_ABSOLUTE_PATH') or define('_LD_ABSOLUTE_PATH', str_replace('/modules/mod_ld_dtree','',$path));
defined('_LD_FRONTEND_PATH') or define('_LD_FRONTEND_PATH', _LD_ABSOLUTE_PATH . '/components/com_linkdirectory');
defined('_LD_BACKEND_PATH') or define('_LD_BACKEND_PATH',_LD_ABSOLUTE_PATH . '/administrator/components/com_linkdirectory');


class mod_ld_dtree_Helper {

	const ROOT_CATID = 'root_catid';
	const CAT_LEVEL = 'cat_level';
	const CLOSE_SAME_LEVEL = 'closesamelevel';

	/**
	 * Liefert die URL zur Javascript-Datei von dtree
	 * @return URK zur zur Javascript-Datei von dtree
	 */
	public function getJsURL(){
		return JURI::base().'includes/js/dtree/dtree.js';
	}

	/**
	 * Liefert die URL zu den Image-Dateien von dtree
	 * @return URL zu den Image-Dateien von dtree
	 */
	public function getImgURL(){
		return JURI::base().'includes/js/dtree/img/';
	}

	/**
	 * Liefert die URL zur CSS-Datei von dtree
	 * @return URL zur CSS-Datei von dtree
	 */
	public function getCssURL(){
		return JURI::base().'includes/js/dtree/dtree.css';
	}

	/**
	 * Liefert den Modul-Parameter CloseSameLevel
	 * @param JParameter $params Modul-Parameter
	 * @return Modul-Parameter CloseSameLevel
	 */
	public function getCloseSameLevel(JParameter &$params){
		return (bool)intval($params->get(self::CLOSE_SAME_LEVEL, 1 ));
	}

	/**
	 * Baut den Javascript-Code für den Kategorien-Bau zusammen
	 *
	 * @param JParameter $Modul-Parameter
	 * @return Javascript für den Kategorieen-Baum oder leer, wenn Komponente 
	 * 		com_linkdirectory nicht installiert bzw. nicht aktiviert ist.
	 */
	public function getdTree(JParameter &$params){
		if (! JComponentHelper:: isEnabled('com_linkdirectory',true)) return;

		$root_catid = intval($params->get(self::ROOT_CATID, 0 ));
		$cat_level = intval($params->get(self::CAT_LEVEL, 2 ));

		$out="";
		$database = &JFactory::getDBO();
		$cats = self::getChildren( $root_catid, $cat_level );
		if ( $root_catid == 0 ) {
			$out .= self::buildDTreeItem(0,-1,JText::_('TOP'),self::getLinkUrl(null,0));
		} else {
			$database->setQuery( "SELECT name id FROM #__ldcats WHERE published='1' AND id ='".$root_catid."'" );
			$name=$database->loadResult();
			if ($name <> NULL) {
				$out.=self::buildDTreeItem($root_catid,-1,$name,self::getLinkUrl('viewcat',$root_catid));
			}
		}
		foreach( $cats AS $cat ) {
			$out.=self::buildDTreeItem($cat->id,$cat->parent_id,$cat->name,self::getLinkUrl('viewcat',$cat->id));
		}
		return $out;
	}

	/**
	 * Liefert ein DTree-Item als Javascript
	 *
	 * @param int $catid Id der Kategorie
	 * @param int $parent_catid Id der Parent-Kategorie
	 * @param String $name Name der Kategorie
	 * @param String $url URL zur Kategorie
	 * @return String dTree Item als Javascript
	 */
	private function buildDTreeItem($catid, $parent_catid, $name, $url){
		return "\n d.add($catid ,$parent_catid,'".htmlspecialchars($name, ENT_QUOTES )."','". $url."');";
	}

	private function getChildren($cat_id, $cat_level){
		$database = &JFactory::getDBO();
		$cat_ids = array();
		if ( $cat_level > 0  ) {
			$sql = "SELECT id, name, parent_id FROM #__ldcats WHERE published='1' AND parent_id='".$cat_id."' ";
			$sql .= "\nORDER BY name ASC";
			$database->setQuery( $sql );
			$cat_ids = $database->loadObjectList();
			if ( count($cat_ids) ) {
				foreach( $cat_ids AS $cid ) {
					$children_ids = self::getChildren( $cid->id, ($cat_level-1) );
					$cat_ids = array_merge( $cat_ids, $children_ids );
				}
			}
		}
		return $cat_ids;
	}

	/**
	 * Ermittelt die URL zur Anzeige von Kategorien in com_linkdirectory
	 *
	 * @param string $task Task, der auf com_linkdirectory ausgeführt werden soll 
	 * @param int $catid Id der Kategorie
	 * @param int $Itemid Itemid
	 * @return URL
	 */
	private function getLinkUrl($task=NULL,$catid=NULL,$Itemid=NULL){
		$url='index.php?option=com_linkdirectory';
		if ($task) $url.='&task='.$task;
		if ($catid) $url.='&catid='.$catid;
		if ($Itemid) $url.='&Itemid='.$Itemid;
		return JRoute::_($url);
	}

	// TODO Prüfen, ob überhaupt noch relevant
	private function getItemid(){
		$database = &JFactory::getDBO();
		$database->setQuery("SELECT id FROM #__menu"
		.	"\nWHERE link='index.php?option=com_linkdirectory'"
		.	"\nLIMIT 1");
		$Itemid = $database->loadResult();
		return $Itemid;
	}
}


?>